#coding=UTF-8
#appModules/msnmsgr.py
#A part of NonVisual Desktop Access (NVDA)
#Copyright (C) 2006-2011 NVDA Contributors <http://www.nvda-project.org/>
#This file is covered by the GNU General Public License.
#See the file COPYING for more details.

import config
import winUser
from NVDAObjects.IAccessible import IAccessible 
import controlTypes
import oleacc
import appModuleHandler
import speech

lastMSNHistoryValue=None
possibleHistoryWindowNames=frozenset([
u'History',
u'Geskiedenis',
u'Verlauf',
u'Historia',
u'Historial',
u'Historique',
u'Cronologia',
u'HistÃ³rico',
u'Histórico',
u'HistÃ³ria',
u'LÆ°á»£c Sá',
u'è¨˜éŒ',
u'Historik',
u'Előzmények',
u'Geçmiş',
u'المحفوظات',
])
possibleStatusWindowNames=frozenset([
u'Texte de la barre d\'\xe9tat',
])
possibleStatusLastMessage=frozenset([
u'Dernier message re\xe7u \xe0',
])

class AppModule(appModuleHandler.AppModule):

	def event_NVDAObject_init(self,obj):
		if obj.name in possibleStatusWindowNames:
			obj.role = controlTypes.ROLE_STATUSBAR

	def event_valueChange(self, obj, nextHandler):
		if obj.name in possibleStatusWindowNames and winUser.isDescendantWindow(winUser.getForegroundWindow(),obj.windowHandle) and config.conf["presentation"]["reportDynamicContentChanges"]:
			isLastReceived = False
			for i in possibleStatusLastMessage:
				if i == obj.value[0:len(i)]:
					isLastReceived = True
					break
				if isLastReceived == False:
					from ui import message
					message(obj.value)
		elif not isinstance(obj,MSNHistory) and obj.name in possibleHistoryWindowNames and winUser.isDescendantWindow(winUser.getForegroundWindow(),obj.windowHandle) and config.conf["presentation"]["reportDynamicContentChanges"]:
			global lastMSNHistoryValue
			value=obj.value
			if value!=lastMSNHistoryValue:
				speech.speakText(value)
				lastMSNHistoryValue=value
		nextHandler()

	def chooseNVDAObjectOverlayClasses(self, obj, clsList):
		if obj.windowClassName==u'WLXDUI' and obj.role==controlTypes.ROLE_ALERT and obj.IAccessibleStates&oleacc.STATE_SYSTEM_ALERT_MEDIUM:
			clsList.insert(0, MSNHistory)

class MSNHistory(IAccessible):

	def _get_value(self):
		try:
			value=self.IAccessibleObject.accValue(self.IAccessibleChildID)
		except COMError:
			value=None
		return value or ""

	def event_valueChange(self):
		global lastMSNHistoryValue
		if winUser.isDescendantWindow(winUser.getForegroundWindow(),self.windowHandle):
			value=self.value
			if value!=lastMSNHistoryValue and config.conf["presentation"]["reportDynamicContentChanges"]:
				speech.speakText(value)
				lastMSNHistoryValue=value
